Package com.avaya.clientservices.call.feature

## Enum FeatureType

- java.lang.Object
- - java.lang.Enum<FeatureType>
  - - com.avaya.clientservices.call.feature.FeatureType

- All Implemented Interfaces:
    `java.io.Serializable`, `java.lang.Comparable<FeatureType>`

      public enum FeatureType
      extends java.lang.Enum<FeatureType>

  Defines the list of supported features. This enum is for all of the features supported by client services, not tailored based on capabilities provisioned for the user in the network (available features). It is also not tailored based on which features are client invokable via CallFeatureService.invokeFeature().

- - ### Enum Constant Summary

    Enum Constants
    Enum Constant | Description
    --- | ---
    `AUTO_CALLBACK` | Auto Callback is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that allows a user who placed a call to a busy or unanswered telephone to be called back automatically when the called telephone becomes available to receive a call.
    `AUTO_CONFERENCE` | This feature can be used to place the user, his current call and any calls he has on hold into a conference.
    `AUTO_INTERCOM` | Automatic intercom feature allows to initiate intercom call to a preconfigured destination.
    `AUTODIAL` | The Autodial feature allows the user or administrator to configure a button as a speed-dial.
    `BUSY_INDICATOR` | Busy Indicator feature allows the user to observe another extension for its availability.
    `CALL_PARK` | Call Park is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that allows the user to place the current call in the call park state so it can be retrieved from another phone.
    `CALL_UNPARK` | Call Unpark is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that allows the user to retrieve a call parked at another extension.
    `CALLBACK_CALL` | This feature allows to place callback calls using one of the destinations configured by the callback/simultaneous ring feature.
    `CALLING_PARTY_NUMBER_BLOCK` | Calling Party Number Block is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that allows a user to block the sending of the calling party number for one call.
    `CALLING_PARTY_NUMBER_UNBLOCK` | Calling Party Number Unblock is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that allows a user to deactivate calling party number (CPN) blocking and allows the CPN to be sent for a single call.
    `CANCEL_ALL_FORWARDING` | This feature cancels all forms of forwarding on the user's extension including "Follow Me" and "Do Not Disturb".
    `DIRECT_DIAL` | This feature allows to call an extension and have the call automatically answered on speaker phone after 3 beeps.
    `DIRECTED_CALL_PICKUP` | Directed Call Pickup is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that allows the user to answer a call ringing at another extension without having to be a member of a pickup group.
    `EC500` | EC500 is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that is used to activate/deactivate EC 500 cellular call extension at a CM station (extension).
    `ENHANCED_CALL_FORWARDING` | Enhanced Call Forwarding is feature that uses a 'Feature-Named-URI' (FNU) that allows a user to configure call forwarding for internal or external calls with seprate settings for busy, no reply, and unconditional forwarding.
    `EXCLUSION` | Exclusion is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that is used to activate/deactivate exclusion by a bridged line appearance user.
    `EXTEND_CALL` | Extend Call is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that is used to extend a call to the off-PBX destinations associated with the extension.
    `EXTENDED_GROUP_CALL_PICKUP` | Extended Group Call Pickup is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that allows a user to answer calls directed to another call pickup group.
    `FORWARD_ALL_CALLS` | Call Forward All is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that is used to activate/deactivate call forwarding for calls coming in at a CM station (extension).
    `FORWARD_BUSY_CALL` | This feature enables forwarding when the user's extension is busy.
    `FORWARD_BUSY_NO_ANSWER_CALLS` | Call Forward Busy No Answer is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that is used to activate/deactivate call forwarding for incoming calls when busy or when not answered by the user at a CM station (extension).
    `FORWARD_BUSY_NUMBER` | This feature sets the number to which the user's calls are forwarded when Forward on Busy or Forward on No Answer are on.
    `FORWARD_NO_ANSWER_CALLS` | This feature enables forwarding when the user's extension is not answered within the period defined by their No Answer Time.
    `FORWARD_NUMBER` | This feature sets the number to which the user's calls are redirected.
    `FORWARD_TO_VOICEMAIL` | This feature allows the user to define voicemail box usage.
    `GROUP_CALL_PICKUP` | Group Call Pickup is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that allows the user to answer a call that is ringing in the user's pickup group.
    `HUNT_GROUP_BUSY_POSITION` | Hunt Group Busy Position is a feature button which allows user to opt-in/opt-out from Hunt Group calls.
    `INTERNAL_TWINNING` | When this feature is active, incoming calls will ring on the user's own extension and another extension within the same IP Office.
    `LIMIT_CALLS` | Limit Number of Concurrent Calls feature: Users can use this to limit the number of concurrent calls at a station to one call, where normally multiple call appearances can terminate at the station.
    `MALICIOUS_CALL_TRACE` | Malicious Call Trace (MCT) feature lets a user to notify SM about a malicious call when a user invokes the Malicious Call Trace feature on an incoming call.
    `MOVE_CALL` | This feature allows the user to Move call to Simultaneous/Twinned clients.
    `NO_HOLD_CONFERENCE` | The No Hold Conference feature allows a user to set up a conference call without interrupting the current conversation.
    `ONE_TOUCH_RECORDING` | One-Touch Recording is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that allows a user to start and end the recording of an in-progress conversation using the AUDIX system recording facility.
    `PRIORITY_CALL` | Priority Call is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that allows a user to place priority calls or change an existing call to a priority call.
    `RETRIEVE_CALL` | This feature allows the user to Retrieve call from Simultaneous/Twinned clients.
    `SEND_ALL_CALLS` | Send All Calls is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that is used to activate/deactivate coverage path for calls coming in at a CM station (extension).
    `SEND_NN` | The Send NN (Send number and name) feature allows the user to place outgoing calls while hiding the caller's number/identity.
    `SERVICE_OBSERVING` | The Service Observing features (SO) allow a supervisor or other authorized user to use their telephone to activate an observing session towards a station, an agent LoginID or VDN to listen in and possibly talk on calls received by the station/agent or VDN for the purposes of quality control and training.
    `SIM_RING_CALLBACK` | This feature allows to configure parameters for simultaneous ringing on incoming calls and/or originating callback call.
    `STATION_LOGOUT` | This feature logs the user off the phone or soft client he is currently logged in.
    `TEAM_BUTTON` | The Team Button feature allows the user to view the state of another station and allow the user to answer any calls which are actively ringing on that station.
    `UNDEFINED` | Uninitialized (or unknown) feature type.
    `WHISPER_PAGE` | Whisper Page is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that allows the user to to make and receive whisper pages.

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static FeatureType` | `valueOf​(java.lang.String name)` | Returns the enum constant of this type with the specified name.
    `static FeatureType[]` | `values()` | Returns an array containing the constants of this enum type, in the order they are declared.

    - ### Methods inherited from class java.lang.Enum

      `compareTo, equals, getDeclaringClass, hashCode, name, ordinal, toString, valueOf`

    - ### Methods inherited from class java.lang.Object

      `getClass, notify, notifyAll, wait, wait, wait`

- - ### Enum Constant Detail

    - #### UNDEFINED

          public static final FeatureType UNDEFINED

      Uninitialized (or unknown) feature type.

    - #### SEND_ALL_CALLS

          public static final FeatureType SEND_ALL_CALLS

      Send All Calls is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that is used to activate/deactivate coverage path for calls coming in at a CM station (extension). In summary, the feature activates/de-activates call coverage at CM. Depending on how CM extension is provisioned, the calls may be covered to another extension, voice mail, etc. Incoming priority calls are not affected by the feature's status, that is, incoming priority calls do not get covered as a result of activating the SAC feature. It should be noted that the SAC feature FNU may be used to apply to local user's CM extension as well as to a third party CM extension (avaya-cm-destination).

    - #### FORWARD_ALL_CALLS

          public static final FeatureType FORWARD_ALL_CALLS

      Call Forward All is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that is used to activate/deactivate call forwarding for calls coming in at a CM station (extension). In summary, the feature activates/de-activates\ call forwarding at CM. It should be noted that the call forward all feature FNU may be used to apply to local user's CM extension as well as to a third party CM extension (avaya-cm-destination).

    - #### FORWARD_BUSY_NO_ANSWER_CALLS

          public static final FeatureType FORWARD_BUSY_NO_ANSWER_CALLS

      Call Forward Busy No Answer is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that is used to activate/deactivate call forwarding for incoming calls when busy or when not answered by the user at a CM station (extension). In summary, the feature activates/de-activates call forwarding at CM. It should be noted that this feature FNU may be used to apply to local user's CM extension as well as to a third party CM extension (avaya-cm-destination).

    - #### EXCLUSION

          public static final FeatureType EXCLUSION

      Exclusion is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that is used to activate/deactivate exclusion by a bridged line appearance user. In summary, the feature activates/de-activates exclusion at the CM station associated with the user.

    - #### EC500

          public static final FeatureType EC500

      EC500 is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that is used to activate/deactivate EC 500 cellular call extension at a CM station (extension). In summary, the feature activates/de-activates EC500 feature at CM station.

    - #### EXTEND_CALL

          public static final FeatureType EXTEND_CALL

      Extend Call is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that is used to extend a call to the off-PBX destinations associated with the extension. In summary, the feature invokes extend call at the CM station associated with the user.

    - #### CALL_PARK

          public static final FeatureType CALL_PARK

      Call Park is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that allows the user to place the current call in the call park state so it can be retrieved from another phone. In summary, the feature invokes call park at the CM station associated with the user.

    - #### CALL_UNPARK

          public static final FeatureType CALL_UNPARK

      Call Unpark is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that allows the user to retrieve a call parked at another extension. In summary, the feature invokes call unpark at the CM station associated with the user.

    - #### AUTO_CALLBACK

          public static final FeatureType AUTO_CALLBACK

      Auto Callback is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that allows a user who placed a call to a busy or unanswered telephone to be called back automatically when the called telephone becomes available to receive a call. In summary, the feature activates/de-activates auto-callback at the CM station associated with the user.

    - #### WHISPER_PAGE

          public static final FeatureType WHISPER_PAGE

      Whisper Page is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that allows the user to to make and receive whisper pages. A whisper page is an announcement sent to another extension that is active on a call where only the person on the extension hears the announcement; any other parties on the call cannot hear the announcement. In summary, the feature activates/de-activates whisper page at the CM station associated with the user.

    - #### GROUP_CALL_PICKUP

          public static final FeatureType GROUP_CALL_PICKUP

      Group Call Pickup is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that allows the user to answer a call that is ringing in the user's pickup group. In summary, the feature invokes group call pickup at the CM station associated with the user.

    - #### EXTENDED_GROUP_CALL_PICKUP

          public static final FeatureType EXTENDED_GROUP_CALL_PICKUP

      Extended Group Call Pickup is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that allows a user to answer calls directed to another call pickup group. In summary, the feature invokes extended group call pickup at the CM station associated with the user.

    - #### CALLING_PARTY_NUMBER_BLOCK

          public static final FeatureType CALLING_PARTY_NUMBER_BLOCK

      Calling Party Number Block is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that allows a user to block the sending of the calling party number for one call. In summary, the feature invokes calling party number block at the CM station associated with the user.

    - #### CALLING_PARTY_NUMBER_UNBLOCK

          public static final FeatureType CALLING_PARTY_NUMBER_UNBLOCK

      Calling Party Number Unblock is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that allows a user to deactivate calling party number (CPN) blocking and allows the CPN to be sent for a single call. In summary, the feature invokes calling party number unblock at the CM station associated with the user.

    - #### ONE_TOUCH_RECORDING

          public static final FeatureType ONE_TOUCH_RECORDING

      One-Touch Recording is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that allows a user to start and end the recording of an in-progress conversation using the AUDIX system recording facility. In summary, the feature invokes one-touch recording at the CM station associated with the user.

    - #### DIRECTED_CALL_PICKUP

          public static final FeatureType DIRECTED_CALL_PICKUP

      Directed Call Pickup is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that allows the user to answer a call ringing at another extension without having to be a member of a pickup group. In summary, the feature invokes directed call pickup at the CM station associated with the user.

    - #### PRIORITY_CALL

          public static final FeatureType PRIORITY_CALL

      Priority Call is an AST-I feature that uses a 'Feature-Named-URI' (FNU) that allows a user to place priority calls or change an existing call to a priority call. In summary, the feature invokes priority call at the CM station associated with the user.

    - #### ENHANCED_CALL_FORWARDING

          public static final FeatureType ENHANCED_CALL_FORWARDING

      Enhanced Call Forwarding is feature that uses a 'Feature-Named-URI' (FNU) that allows a user to configure call forwarding for internal or external calls with seprate settings for busy, no reply, and unconditional forwarding. In summary, the feature invokes enhanced call forwarding at the CM station associated with the user.

    - #### BUSY_INDICATOR

          public static final FeatureType BUSY_INDICATOR

      Busy Indicator feature allows the user to observe another extension for its availability. When the far end destination goes off-hook, the server notifies the same via <feature name ="busy-indicator" status="on"/> When the far end destination goes on-hook, the server notifies the same via <feature name ="busy-indicator" status="off"/>

    - #### AUTODIAL

          public static final FeatureType AUTODIAL

      The Autodial feature allows the user or administrator to configure a button as a speed-dial. User can edit the autodial Label and/or autodial number. The destinationLabel is always editable but destinationExtension is editable only if the IsDestinationExtensionEditable flag is true.

    - #### HUNT_GROUP_BUSY_POSITION

          public static final FeatureType HUNT_GROUP_BUSY_POSITION

      Hunt Group Busy Position is a feature button which allows user to opt-in/opt-out from Hunt Group calls. If your admin have configured your extension as a member of a hunt group, you will be eligible to receive calls made to that hunt group. When you don't want to receive calls on that hunt group, the feature needs to be enabled. When feature is enabled, user will not receive any calls on that Hunt Group. When feature is disabled, user will start recieving the calls on that hunt group again. User can also set the personalized label for the button.

    - #### TEAM_BUTTON

          public static final FeatureType TEAM_BUTTON

      The Team Button feature allows the user to view the state of another station and allow the user to answer any calls which are actively ringing on that station. The button can also be used as a speed dial to call the monitored station when it is idle.

    - #### MALICIOUS_CALL_TRACE

          public static final FeatureType MALICIOUS_CALL_TRACE

      Malicious Call Trace (MCT) feature lets a user to notify SM about a malicious call when a user invokes the Malicious Call Trace feature on an incoming call.

    - #### NO_HOLD_CONFERENCE

          public static final FeatureType NO_HOLD_CONFERENCE

      The No Hold Conference feature allows a user to set up a conference call without interrupting the current conversation. The called party is automatically added to the conference as soon as they answer.

    - #### SERVICE_OBSERVING

          public static final FeatureType SERVICE_OBSERVING

      The Service Observing features (SO) allow a supervisor or other authorized user to use their telephone to activate an observing session towards a station, an agent LoginID or VDN to listen in and possibly talk on calls received by the station/agent or VDN for the purposes of quality control and training.

    - #### FORWARD_BUSY_CALL

          public static final FeatureType FORWARD_BUSY_CALL

      This feature enables forwarding when the user's extension is busy. It uses the Forward Number destination or, if set, the Forward on Busy Number destination. If the user has call appearance buttons programmed, the system will not treat them as busy until all the call appearance buttons are in use. Note that this feature differs from the feature FORWARD_BUSY_NO_ANSWER_CALLS since the latter one serves invocation of both busy and not answered cases (for platforms where the two cases can not be supported separately).

    - #### FORWARD_NO_ANSWER_CALLS

          public static final FeatureType FORWARD_NO_ANSWER_CALLS

      This feature enables forwarding when the user's extension is not answered within the period defined by their No Answer Time. It uses the Forward Number destination or, if set, the Forward on Busy Number destination. Note that this feature differs from the feature FORWARD_BUSY_NO_ANSWER_CALLS since the latter one serves invocation of both busy and not answered cases (for platforms where the two cases can not be supported separately).

    - #### FORWARD_NUMBER

          public static final FeatureType FORWARD_NUMBER

      This feature sets the number to which the user's calls are redirected. This can be an internal or external number. This feature does not activate forwarding; it only sets the number for the forwarding destination. This number is used for all forward types; Forward Unconditional, Forward on Busy and Forward on No Answer, unless the user has a separate Forward on Busy Number set for forward on busy and forward on no answer functions.

    - #### FORWARD_BUSY_NUMBER

          public static final FeatureType FORWARD_BUSY_NUMBER

      This feature sets the number to which the user's calls are forwarded when Forward on Busy or Forward on No Answer are on. If no Forward on Busy Number is set, those functions use the Forward Number. This feature does not activate the forwarding, it only sets the number for the forwarding destination.

    - #### AUTO_CONFERENCE

          public static final FeatureType AUTO_CONFERENCE

      This feature can be used to place the user, his current call and any calls he has on hold into a conference. If the call on hold is an existing conference, the user and any current call are added to that conference.

    - #### CANCEL_ALL_FORWARDING

          public static final FeatureType CANCEL_ALL_FORWARDING

      This feature cancels all forms of forwarding on the user's extension including "Follow Me" and "Do Not Disturb".

    - #### FORWARD_TO_VOICEMAIL

          public static final FeatureType FORWARD_TO_VOICEMAIL

      This feature allows the user to define voicemail box usage. When feature is enabled: the user's voicemail mailbox is used to answer calls which ring unanswered or arrive when the user is busy. When feature is disabled: the user's voicemail mailbox box is not being used to answer calls. This does not disable the voicemail mailbox being used as the target for other functions such as call recording or messages forwarded from other mailboxes.

    - #### STATION_LOGOUT

          public static final FeatureType STATION_LOGOUT

      This feature logs the user off the phone or soft client he is currently logged in. Results in regular logout process for the environments/platforms which do not let the user to logout without this feature assigned.

    - #### DIRECT_DIAL

          public static final FeatureType DIRECT_DIAL

      This feature allows to call an extension and have the call automatically answered on speaker phone after 3 beeps. The extension called must support a handsfree speaker. If the extension does not have a handsfree microphone then the user must use the handset if they want to talk. If the extension is not free when called, the call is presented as a normal call on a call appearance button if available.

    - #### LIMIT_CALLS

          public static final FeatureType LIMIT_CALLS

      Limit Number of Concurrent Calls feature: Users can use this to limit the number of concurrent calls at a station to one call, where normally multiple call appearances can terminate at the station.

    - #### MOVE_CALL

          public static final FeatureType MOVE_CALL

      This feature allows the user to Move call to Simultaneous/Twinned clients.

    - #### RETRIEVE_CALL

          public static final FeatureType RETRIEVE_CALL

      This feature allows the user to Retrieve call from Simultaneous/Twinned clients.

    - #### INTERNAL_TWINNING

          public static final FeatureType INTERNAL_TWINNING

      When this feature is active, incoming calls will ring on the user's own extension and another extension within the same IP Office. This feature can only be configured by the IP Office administrator. User will not be able to activate/deactivate this feature.

    - #### AUTO_INTERCOM

          public static final FeatureType AUTO_INTERCOM

      Automatic intercom feature allows to initiate intercom call to a preconfigured destination.

    - #### SIM_RING_CALLBACK

          public static final FeatureType SIM_RING_CALLBACK

      This feature allows to configure parameters for simultaneous ringing on incoming calls and/or originating callback call.

    - #### CALLBACK_CALL

          public static final FeatureType CALLBACK_CALL

      This feature allows to place callback calls using one of the destinations configured by the callback/simultaneous ring feature.
      See Also:
        `SIM_RING_CALLBACK`

    - #### SEND_NN

          public static final FeatureType SEND_NN

      The Send NN (Send number and name) feature allows the user to place outgoing calls while hiding the caller's number/identity.

  - ### Method Detail

    - #### values

          public static FeatureType[] values()

      Returns an array containing the constants of this enum type, in the order they are declared. This method may be used to iterate over the constants as follows:

          for (FeatureType c : FeatureType.values())
              System.out.println(c);

      Returns:
        an array containing the constants of this enum type, in the order they are declared

    - #### valueOf

          public static FeatureType valueOf​(java.lang.String name)

      Returns the enum constant of this type with the specified name. The string must match exactly an identifier used to declare an enum constant in this type. (Extraneous whitespace characters are not permitted.)
      Parameters:
        `name` - the name of the enum constant to be returned.
      Returns:
        the enum constant with the specified name
      Throws:
        `java.lang.IllegalArgumentException` - if this enum type has no constant with the specified name
        `java.lang.NullPointerException` - if the argument is null